//: Playground - noun: a place where people can play

import Foundation
import UIKit
import XCPlayground
import SceneKit


let width  = 512
let height = 512
let objectCount = 6

func makeScene() -> SCNScene {
    var colorIndex = 0
    let scene = SCNScene()
    let sphereGeometry = SCNSphere(radius: 1.0)
    let boxNode = SCNNode(geometry: sphereGeometry)
    scene.rootNode.addChildNode(boxNode)
    
    var y: Float = 0.0
    let radius:CGFloat = 1.0
    for _ in 0..<objectCount {
        var x:Float = 0.0
        for _ in 0..<objectCount {
            let sphereGeometry = SCNSphere(radius: radius)
            sphereGeometry.firstMaterial?.diffuse.contents = colorIndex % 2 == 0 ? UIColor.orangeColor() : UIColor.whiteColor()
            colorIndex++
            let sphereNode = SCNNode(geometry: sphereGeometry)
            sphereNode.position = SCNVector3(x: x, y: y, z: 0.0)
            scene.rootNode.addChildNode(sphereNode)
            x += 2 * Float(radius)
        }
        y += 2 * Float(radius)
    }
    return scene
}

let scene = makeScene()
let scnView = SCNView(frame: CGRect(x: 0, y: 0, width: 512, height: 512))
scnView.backgroundColor = UIColor.blackColor()
scnView.scene = scene
scnView.autoenablesDefaultLighting = true
XCPShowView("SCNView", view: scnView)
