// Playground - noun: a place where people can play

import UIKit

class People:NSObject {
    var weight : Double = 0.0
    // （１）値の検証
    func validateWeit(value: AutoreleasingUnsafeMutablePointer<AnyObject?>) throws {
        if value == nil {
            return
        }
        guard let valueDouble = value.memory as? Double else {
            // Double ではないのでデフォルト値を返す
            value.memory = 30.0
            return
        }
        if valueDouble > 200.0 || valueDouble < 30.0 { // （２）範囲確認
            // 然るべきエラーを投げる
            throw NSError(domain: " 範囲外", code: -1, userInfo: [:])
        }
    }
}
var people = People()
var value : AnyObject? = 20.8
// （３）weightの値が20.8でバリデーションチェック
do {
    try people.validateWeit(&value)
    print("\(value)")
}
catch(let error) {
    print((error as NSError).domain) // "範囲外"
}
