//
//  WeatherResult.swift
//  8-3-5_HimotokiSample
//
//  Created by oga on 2015/09/20.
//  Copyright © 2015年 Ryuji Watanabe. All rights reserved.
//

import Foundation
import Himotoki

struct WeatherResult: Decodable {
    let cityName: String
    let weathers: [Weather]
    
    static func decode(e: Extractor) -> WeatherResult? {
        return build(WeatherResult.init)(
            e <|  "name",
            e <|| "weather"
        )
    }
}

struct Weather: Decodable {
    let weatherID : Int
    let main: String
    let description: String
    let icon: String
    
    static func decode(e: Extractor) -> Weather? {
        return build(Weather.init)(
            e <| "id",
            e <| "main",
            e <| "description",
            e <| "icon"
        )
    }
}