//: Playground - noun: a place where people can play

import UIKit

class Model : NSObject {
    // （１）dynamic でKVO で使えるようにする
    dynamic var text = ""
}
class Sample: NSObject {
    let model = Model()
    override init() {
        super.init()
        self.startObserving()
    }
    // （２）オブザーバの設定
    func startObserving() {
        model.addObserver(self, forKeyPath: "text", options: .New, context: nil)
    }
    // （３）変更通知の受信
    override func observeValueForKeyPath(keyPath: String?,
        ofObject object: AnyObject?,
        change: [String : AnyObject]?,
        context: UnsafeMutablePointer<Void>)
    {
        if keyPath != "text" { return }
        if let newText = change?[NSKeyValueChangeNewKey] as? String {
            print("new \(newText)")
        }
    }
}
let sample = Sample()
// （４）モデルにテキストをセット
sample.model.text = "Yukichi"
// "new Yukichi"

