// コード8.59 NSCopying の実装

import UIKit

enum AnimalType {
    case Unknown, Cat, Dog, Lion, Tiger
}
class Animal: NSObject, NSCopying {
    var name:String = ""
    var type:AnimalType = .Unknown
    init(type: AnimalType) {
        self.type = type
    }
    func copyWithZone(zone: NSZone) -> AnyObject {
        let newInstance = Animal(type: type)
        newInstance.name = name
        return newInstance
    }
}
let dog = Animal(type: .Dog)
dog.name = "donta"
let yukichi = dog.copy() as! Animal
print(yukichi.name) // "donta"
yukichi.name = "yukichi"
let isDog = yukichi.type == AnimalType.Dog
print(isDog) // true
