// コード8.63 Factory Method パターンの例

import UIKit

protocol SimpleClassProtocol {
    func name() -> String
}
class ClassA: SimpleClassProtocol {
    func name() -> String {
        return "ClassA"
    }
}
class ClassB {
    private let classA: SimpleClassProtocol = ClassA()
    func subClassName() -> String {
        return classA.name()
    }
}
let classB = ClassB()
print(classB.subClassName()) // "ClassA"